package birc.grni.gui;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.PrintStream;
import java.util.HashMap;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import birc.grni.rf.Genie3Time;


public class GrnRf extends GrnRfDisplay
{
	public static final HashMap<String, String> treeMethodMap;
	public static final String[] treeMethods = 
		{
			"RF-Random Forests", 
			"ET-Extra Trees"
		};
	
	static
	{
		treeMethodMap = new HashMap<String, String>();
		treeMethodMap.put("RF-Random Forests", "RF");
		treeMethodMap.put("ET-Extra Trees", "ET");
	}
	
	public GrnRf(JFrame frame)
	{
		super(frame);
		
		headerRf.setTitle("Set parameters for Random Forests");
		headerRf.setInfo("Enter parameters and click start button");
		headerRf.setTopColor(Color.RED);
		headerRf.setBottomColor(Color.PINK);
		
		startButton.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				
				String inputFilePath = dataFilePathField.getText();
				String treeMethod = treeMethodMap.get((String)treeMethodComboBox.getSelectedItem());
				int nbTrees = Integer.parseInt(nbTreesField.getText());
				
				try
				{
					/* run algorithm*/
					//TEST
					//double[][] VIM = Genie3Time.run(inputFilePath, treeMethod, nbTrees);
					
					//TEST
					/* initialize the algorithm and progress bar*/
					Genie3Time genie3Time = new Genie3Time();
					genie3Time.init(inputFilePath, treeMethod, nbTrees);
					
					/* run the algorithm*/
					genie3Time.execute();
					
					//TEST
//					if(JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(null, "Do you want to save the result?", "Save Result", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null))
//					{
//						/* pop up the file chooser window*/
//						JFileChooser chooser = new JFileChooser();
//					    int returnVal = chooser.showSaveDialog(null);
//					    if(returnVal == JFileChooser.APPROVE_OPTION) {
//					    	String resultSavePath = chooser.getSelectedFile().getAbsolutePath();
//					    	/* write result into the file indicated by resultSavePath*/
//							PrintStream resultFilePrinter = new PrintStream(new File(resultSavePath));
//							for(int i = 0; i< VIM.length; i++)
//							{
//								for(int j = 0; j< VIM[0].length; j++)
//									resultFilePrinter.printf("%4.0f", VIM[i][j]);
//								resultFilePrinter.printf("\n");
//							}
//							resultFilePrinter.close();
//					    }
//					}
				}
				catch (Exception exception)
				{
					exception.printStackTrace();
				}
			}
		});
		
		//TEST
//		exitButton.addActionListener(new ActionListener() {
//			
//			@Override
//			public void actionPerformed(ActionEvent e) {
//				//System.exit(0);
//				frameRf.dispose();
//			}
//		});
	}
}