package edu.ksu.cis.kdd.util.parser;

/* Generated By:JJTree: Do not edit this line. Node.java */
/*
 * This file is part of Bayesian Network for Java (BNJ).
 *
 * BNJ is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BNJ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BNJ in LICENSE.txt file; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* All AST nodes must implement this interface.  It provides basic
   machinery for constructing the parent and child relationships
   between nodes. */

public interface Node {

  /** Accept the visitor. **/
  public Object jjtAccept(ParserVisitor visitor, Object data);  
  /** This method tells the node to add its argument to the node's
	list of children.  */
  public void jjtAddChild(Node n, int i);  
  /** This method is called after all the child nodes have been
	added. */
  public void jjtClose();  
  /** This method returns a child node.  The children are numbered
	 from zero, left to right. */
  public Node jjtGetChild(int i);  
  /** Return the number of children the node has. */
  public int jjtGetNumChildren();  
  public Node jjtGetParent();  
  /** This method is called after the node has been made the current
	node.  It indicates that child nodes can now be added to it. */
  public void jjtOpen();  
  /** This pair of methods are used to inform the node of its
	parent. */
  public void jjtSetParent(Node n);  
}
