function example(n)
% n is the dimension (number of equations) of the system
%
% Thomas Schaffter, Ph.D. Student
% Ecole Polytechnique Federale de Lausanne (EPFL)
% Laboratory of Intelligent Systems (LIS)
% CH-1015 Lausanne, Switzerland
% http://lis.epfl.ch/161219

% load time series data generated by the Main class of libSDE
X = load('../example/exampleSDE_timeseries.tsv');
t = X(:,1); % extract time scale

% plot all the n trajectories
for i=1:n
   X1 = X(:,i+1);
   plot(t,X1,'.-');
   hold on;
end

hold on

% plot the exact solution in high resolution
t = 0:0.00001:1;
s = 2/3 *exp(-3*t) + 1/3;
plot(t,s, 'r');
axis([0 1 0 1.2])

xlabel('Time');
ylabel('X');

end
